Index: /code/trunk/bin/levels/sample.oxw
===================================================================
--- /code/trunk/bin/levels/sample.oxw	(revision 870)
+++ /code/trunk/bin/levels/sample.oxw	(revision 871)
@@ -1,15 +1,3 @@
-<?xml version="1.0"?>
-<orxonoxworld name="Orxonox sample level" image="textures/menu/moonstation_512x512.jpg">
-  <description>
-    This is an orxonox sample level.
-  </description>
-
-  <loading>
-    <background color="000000" image="textures/load_screens/ambush.png" />
-    <bar top="200" left="50" width="300" height="20" image="textures/load_screens/ambush-loadbar.png" />
-  </loading>
-
-
-
+<!--
  <audio>
 		<ambient>
@@ -21,33 +9,34 @@
 		</ambient>
   </audio>
-
-  <!-- Keep a minimum distance of >100 to the object, otherwise the camara thinks it's in the object -->
-  <!-- the value has to negative, as we want the camara behind the object -->
-<!--
-    <Camera name="Camera" pos="0,50,-150" lookat="0,20,0" node="2OgreHeadNode" />
-    <SpaceShip camera="true" position="0,0,0" scale="10" yaw="-90" pitch="-90" mesh="assf3.mesh"  forward="250" rotateupdown="100" rotaterightleft="100" looprightleft="100" />
 -->
-  <world>
-    <Ambient colourvalue="1,1,1" />
-    <Skybox src="Orxonox/StarSkyBox" />
-
-    <!--Fighter camera="true" position="0,0,0" scale="10" yaw="-90" pitch="-90" mesh="assf3.mesh"  forward="500" rotateupdown="200" rotaterightleft="200" looprightleft="200" /-->
-    <SpaceShip camera="true" position="0,0,0" scale="10" yaw="-90" pitch="-90" mesh="assf3.mesh" maxSpeed="500" maxSideAndBackSpeed="50" maxRotation="1.0" transAcc="200" rotAcc="3.0" transDamp="75" rotDamp="1.0" />
-
-    <NPC position="0,100,400" scale="1" mesh="razor.mesh"/>
-    <NPC position="0,100,400" scale="1" mesh="razor.mesh"/>
-    <NPC position="0,-100,500" scale="1" mesh="razor.mesh"/>
-    <NPC position="0,-200,450" scale="1" mesh="razor.mesh"/>
-    <NPC position="100,0,400" scale="1" mesh="razor.mesh"/>
-<!--
-    <Model position="200,0,500" scale="10" mesh="starship.mesh" yaw="-90" pitch="-90" />
-    <Model position="-200,0,500" scale="10" mesh="drone.mesh" yaw="-90" pitch="-90" />
--->
-    <Model position="-200,1000,500" scale="10" mesh="hoover_body.mesh" yaw="-90" pitch="-90" />
-    <Model position="-200,1000,500" scale="10" mesh="hoover_gear0.mesh" yaw="-90" pitch="-90" />
-    <Model position="-200,1000,500" scale="10" mesh="hoover_gear1.mesh" yaw="-90" pitch="-90" />
-    <Model position="-200,1000,500" scale="10" mesh="hoover_gear2.mesh" yaw="-90" pitch="-90" />
-    <Model position="-200,1000,500" scale="10" mesh="hoover_turbine.mesh" yaw="-90" pitch="-90" />
-
+
+<Ambient colourvalue="1,1,1" />
+<Skybox src="Orxonox/StarSkyBox" />
+
+<!--Fighter camera="true" position="0,0,0" scale="10" yawpitchroll="-90,-90,0" mesh="assf3.mesh"  forward="500" rotateupdown="200" rotaterightleft="200" looprightleft="200" /-->
+<SpaceShip camera="true" position="0,0,0" scale="10" yawpitchroll="-90,-90,0" mesh="assf5.mesh" maxSpeed="500" maxSideAndBackSpeed="50" maxRotation="1.0" transAcc="200" rotAcc="3.0" transDamp="75" rotDamp="1.0" />
+
+<NPC position="0,100,400" scale="1" mesh="razor.mesh"/>
+<NPC position="0,100,400" scale="1" mesh="razor.mesh"/>
+<NPC position="0,-100,500" scale="1" mesh="razor.mesh"/>
+<NPC position="0,-200,450" scale="1" mesh="razor.mesh"/>
+<NPC position="100,0,400" scale="1" mesh="razor.mesh"/>
+
+<Model name="starship" position="200,0,500" scale="10" mesh="starship.mesh" yawpitchroll="-90,-90,0" />
+<Model name="drone" position="-200,0,500" scale="10" mesh="drone.mesh" yawpitchroll="-90,-90,0">
+  <attached>
+    <Model name="drone2" position="200,-100,-500" scale="10" mesh="drone.mesh" yawpitchroll="-90,-90,0">
+      <attached>
+        <Model name="starship2" position="500,200,-500" scale="10" mesh="starship.mesh" yawpitchroll="-90,-90,0" />
+      </attached>
+    </Model>
+  </attached>
+</Model>
+
+<Model position="-200,1000,500" scale="10" mesh="hoover_body.mesh" yawpitchroll="-90,-90,0" />
+<Model position="-200,1000,500" scale="10" mesh="hoover_gear0.mesh" yawpitchroll="-90,-90,0" />
+<Model position="-200,1000,500" scale="10" mesh="hoover_gear1.mesh" yawpitchroll="-90,-90,0" />
+<Model position="-200,1000,500" scale="10" mesh="hoover_gear2.mesh" yawpitchroll="-90,-90,0" />
+<Model position="-200,1000,500" scale="10" mesh="hoover_turbine.mesh" yawpitchroll="-90,-90,0" />
 
     <Model position="-16779,42,11043" scale="95" mesh="ast2.mesh" rotationAxis="0.281711,0.152518,0" rotationRate="27" />
@@ -278,13 +267,2 @@
     <Model position="-6787,1792,287" scale="71" mesh="ast6.mesh" rotationAxis="0.161019,0.130015,0" rotationRate="36" />
     <Model position="-7223,-13574,-11873" scale="24" mesh="ast4.mesh" rotationAxis="0.792203,0,0.177188" rotationRate="38" />
-
-
-  </world>
-
-  <!-- Unused at the moment -->
-<!--  <SpaceshipSteeringObject node="OgreHeadNode" forward="500" rotateupdown="200" rotaterightleft="200" looprightleft="200" /> -->
-
-  <scripts>
-    <script file="intro.lua" />
-  </scripts>
-</orxonoxworld>
Index: /code/trunk/src/CMakeLists.txt
===================================================================
--- /code/trunk/src/CMakeLists.txt	(revision 870)
+++ /code/trunk/src/CMakeLists.txt	(revision 871)
@@ -6,4 +6,4 @@
 ADD_SUBDIRECTORY(audio)
 ADD_SUBDIRECTORY(network)
-ADD_SUBDIRECTORY(loader)
+#ADD_SUBDIRECTORY(loader)
 ADD_SUBDIRECTORY(orxonox)
Index: /code/trunk/src/network/GameStateClient.cc
===================================================================
--- /code/trunk/src/network/GameStateClient.cc	(revision 870)
+++ /code/trunk/src/network/GameStateClient.cc	(revision 871)
@@ -82,5 +82,5 @@
         // bad luck ;)
         // delete the synchronisable (obviously seems to be deleted on the server)
-        while(it != 0 && it->objectID!=sync.objectID){
+        while(it && it->objectID!=sync.objectID){
           removeObject(it);
         }
Index: /code/trunk/src/network/GameStateManager.cc
===================================================================
--- /code/trunk/src/network/GameStateManager.cc	(revision 870)
+++ /code/trunk/src/network/GameStateManager.cc	(revision 871)
@@ -109,5 +109,5 @@
     int offset=0;
     // go through all Synchronisables
-    for(it = orxonox::ObjectList<Synchronisable>::start(); it != 0; ++it){
+    for(it = orxonox::ObjectList<Synchronisable>::start(); it; ++it){
       //std::cout << "gamestatemanager: in for loop" << std::endl;
       //get size of the synchronisable
Index: /code/trunk/src/network/Synchronisable.cc
===================================================================
--- /code/trunk/src/network/Synchronisable.cc	(revision 870)
+++ /code/trunk/src/network/Synchronisable.cc	(revision 871)
@@ -14,4 +14,5 @@
 
 #include "Synchronisable.h"
+#include "core/CoreIncludes.h"
 
 namespace network
Index: /code/trunk/src/network/Synchronisable.h
===================================================================
--- /code/trunk/src/network/Synchronisable.h	(revision 870)
+++ /code/trunk/src/network/Synchronisable.h	(revision 871)
@@ -2,5 +2,5 @@
 // C++ Interface: synchronisable
 //
-// Description: 
+// Description:
 //
 //
@@ -16,5 +16,5 @@
 
 #include "NetworkPrereqs.h"
-#include "core/CoreIncludes.h"
+#include "core/OrxonoxClass.h"
 
 namespace network
@@ -47,5 +47,5 @@
   public:
 
-    virtual ~Synchronisable();
+      virtual ~Synchronisable();
     int objectID;
     int classID;
@@ -66,11 +66,4 @@
     int datasize;
   };
-
-}
-
-namespace orxonox
-{
-  template class _NetworkExport ClassIdentifier<network::Synchronisable>;
-  template class _NetworkExport ObjectList<network::Synchronisable>;
 }
 
Index: /code/trunk/src/orxonox/CMakeLists.txt
===================================================================
--- /code/trunk/src/orxonox/CMakeLists.txt	(revision 870)
+++ /code/trunk/src/orxonox/CMakeLists.txt	(revision 871)
@@ -3,4 +3,5 @@
   Main.cc
   Orxonox.cc
+  objects/Tickable.cc
   SpaceshipSteering.cc
   hud/HUD.cc
@@ -9,4 +10,5 @@
   tools/Light.cc
   tools/Mesh.cc
+  tools/Timer.cc
   objects/Ambient.cc
   objects/Camera.cc
@@ -18,8 +20,8 @@
   objects/Skybox.cc
   objects/SpaceShip.cc
-# objects/SpaceshipSteeringObject.cc
-# objects/test1.cc
-# objects/test2.cc
-# objects/test3.cc
+#  objects/SpaceshipSteeringObject.cc
+#  objects/test1.cc
+#  objects/test2.cc
+#  objects/test3.cc
   objects/WorldEntity.cc
   objects/weapon/AmmunitionDump.cc
@@ -42,5 +44,5 @@
   audio
   network
-  loader
+#  loader
 )
 
Index: /code/trunk/src/orxonox/Orxonox.cc
===================================================================
--- /code/trunk/src/orxonox/Orxonox.cc	(revision 870)
+++ /code/trunk/src/orxonox/Orxonox.cc	(revision 871)
@@ -57,5 +57,5 @@
 
 // loader and audio
-#include "loader/LevelLoader.h"
+//#include "loader/LevelLoader.h"
 #include "audio/AudioManager.h"
 
@@ -72,4 +72,5 @@
 #include "core/Factory.h"
 #include "core/Debug.h"
+#include "core/Loader.h"
 #include "hud/HUD.h"
 #include "objects/weapon/BulletManager.h"
@@ -131,5 +132,5 @@
     this->ogre_ = new GraphicsEngine();
     this->dataPath_ = "";
-    this->loader_ = 0;
+//    this->loader_ = 0;
     this->auMan_ = 0;
     this->singletonRef_ = 0;
@@ -379,6 +380,8 @@
 
     // load this file from config
-    loader_ = new loader::LevelLoader("sample.oxw");
-    loader_->loadLevel();
+//    loader_ = new loader::LevelLoader("sample.oxw");
+//    loader_->loadLevel();
+    Level* startlevel = new Level("levels/sample.oxw");
+    Loader::open(startlevel);
 
     Ogre::Overlay* hudOverlay = Ogre::OverlayManager::getSingleton().getByName("Orxonox/HUD1.2");
Index: /code/trunk/src/orxonox/Orxonox.h
===================================================================
--- /code/trunk/src/orxonox/Orxonox.h	(revision 870)
+++ /code/trunk/src/orxonox/Orxonox.h	(revision 871)
@@ -14,5 +14,5 @@
 
 #include "OrxonoxPrereqs.h"
-#include "loader/LoaderPrereqs.h"
+//#include "loader/LoaderPrereqs.h"
 #include "audio/AudioPrereqs.h"
 
@@ -69,5 +69,5 @@
       GraphicsEngine*       ogre_;          //!< our dearest graphics engine <3
       std::string           dataPath_;      //!< path to data
-      loader::LevelLoader*  loader_;        //!< level loader builds the scene
+//      loader::LevelLoader*  loader_;        //!< level loader builds the scene
       audio::AudioManager*  auMan_;         //!< audio manager
       BulletManager*        bulletMgr_;     //!< Keeps track of the thrown bullets
Index: /code/trunk/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- /code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 870)
+++ /code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 871)
@@ -73,5 +73,5 @@
 //#include "audio/AudioManager.h"
 
-#include "core/CoreIncludes.h"
+//#include "core/CoreIncludes.h"
 #include "core/BaseObject.h"
 //#include "core/ArgReader.h"
Index: /code/trunk/src/orxonox/core/BaseObject.cc
===================================================================
--- /code/trunk/src/orxonox/core/BaseObject.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/BaseObject.cc	(revision 871)
@@ -20,5 +20,5 @@
  *
  *   Author:
- *      ...
+ *      Fabian 'x3n' Landau
  *   Co-authors:
  *      ...
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file BaseObject.cc
     @brief Implementation of the BaseObject class.
@@ -33,5 +33,8 @@
 #include "util/tinyxml/tinyxml.h"
 
+#include "core/CoreIncludes.h"
 #include "BaseObject.h"
+#include "XMLPort.h"
+#include "Level.h"
 
 namespace orxonox
@@ -45,4 +48,8 @@
     {
         RegisterRootObject(BaseObject);
+
+        this->bActive_ = true;
+        this->bVisible_ = true;
+        this->level_ = 0;
     }
 
@@ -64,3 +71,23 @@
         }
     }
+
+    /**
+        @brief XML loading and saving.
+        @param xmlelement The XML-element
+        @param loading Loading (true) or saving (false)
+        @return The XML-element
+    */
+    void BaseObject::XMLPort(Element& xmlelement, bool loading)
+    {
+        XMLPortParam(BaseObject, "name", setName, getName, xmlelement, loading);
+    }
+
+    /**
+        @brief Returns the levelfile that loaded this object.
+        @return The levelfile
+    */
+    const std::string& BaseObject::getLevelfile() const
+    {
+        return this->level_->getFile();
+    }
 }
Index: /code/trunk/src/orxonox/core/BaseObject.h
===================================================================
--- /code/trunk/src/orxonox/core/BaseObject.h	(revision 870)
+++ /code/trunk/src/orxonox/core/BaseObject.h	(revision 871)
@@ -1,3 +1,30 @@
-/*!
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
     @file BaseObject.h
     @brief Definition of the BaseObject class.
@@ -10,7 +37,7 @@
 
 #include "CorePrereqs.h"
-#include "util/tinyxml/TinyXMLPrereqs.h"
+#include "util/XMLIncludes.h"
 
-#include "CoreIncludes.h"
+#include "OrxonoxClass.h"
 
 namespace orxonox
@@ -23,6 +50,45 @@
             virtual ~BaseObject();
             virtual void loadParams(TiXmlElement* xmlElem);
+            virtual void XMLPort(Element& xmlelement, bool loading);
+
+            /** @brief Sets the name of the object. @param name The name */
+            inline void setName(const std::string& name) { this->name_ = name; this->changedName(); }
+            /** @brief Returns the name of the object. @return The name */
+            inline const std::string& getName() const { return this->name_; }
+            /** @brief This function gets called if the name of the object changes. */
+            virtual void changedName() {}
+
+            /** @brief Sets the state of the objects activity. @param bActive True = active */
+            inline void setActivity(bool bActive) { this->bActive_ = bActive; this->changedActivity(); }
+            /** @brief Returns the state of the objects activity. @return The state of the activity */
+            inline const bool isActive() const { return this->bActive_; }
+            /** @brief This function gets called if the activity of the object changes. */
+            virtual void changedActivity() {}
+
+            /** @brief Sets the state of the objects visibility. @param bVisible True = visible */
+            inline void setVisibility(bool bVisible) { this->bVisible_ = bVisible; this->changedVisibility(); }
+            /** @brief Returns the state of the objects visibility. @return The state of the visibility */
+            inline const bool isVisible() const { return this->bVisible_; }
+            /** @brief This function gets called if the visibility of the object changes. */
+            virtual void changedVisibility() {}
+
+            /** @brief Sets a pointer to the level that loaded this object. @param level The pointer to the level */
+            inline void setLevel(const Level* level) { this->level_ = level; }
+            /** @brief Returns a pointer to the level that loaded this object. @return The level */
+            inline const Level* getLevel() const { return this->level_; }
+            const std::string& getLevelfile() const;
+
+            /** @brief Sets the indentation of the debug output in the Loader. @param indentation The indentation */
+            inline void setLoaderIndentation(const std::string& indentation) { this->loaderIndentation_ = indentation; }
+            /** @brief Returns the indentation of the debug output in the Loader. @return The indentation */
+            inline const std::string& getLoaderIndentation() const { return this->loaderIndentation_; }
+
+        private:
+            std::string name_;                          //!< The name of the object
+            bool bActive_;                              //!< True = the object is active
+            bool bVisible_;                             //!< True = the object is visible
+            const Level* level_;                        //!< The level that loaded this object
+            std::string loaderIndentation_;             //!< Indentation of the debug output in the Loader
     };
-    ExportClass(BaseObject, Core);
 }
 
Index: /code/trunk/src/orxonox/core/CMakeLists.txt
===================================================================
--- /code/trunk/src/orxonox/core/CMakeLists.txt	(revision 870)
+++ /code/trunk/src/orxonox/core/CMakeLists.txt	(revision 871)
@@ -1,9 +1,9 @@
 SET( CORE_SRC_FILES
+  OrxonoxClass.cc
   BaseObject.cc
   Factory.cc
-  IdentifierList.cc
   Identifier.cc
+  IdentifierDistributor.cc
   MetaObjectList.cc
-  OrxonoxClass.cc
   ConfigValueContainer.cc
   Error.cc
@@ -13,4 +13,8 @@
   OutputHandler.cc
   Language.cc
+  ClassTreeMask.cc
+  Loader.cc
+  Executor.cc
+  XMLPort.cc
 )
 
Index: /code/trunk/src/orxonox/core/ClassFactory.h
===================================================================
--- /code/trunk/src/orxonox/core/ClassFactory.h	(revision 870)
+++ /code/trunk/src/orxonox/core/ClassFactory.h	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file ClassFactory.h
     @brief Definition and implementation of the ClassFactory class
@@ -72,7 +72,7 @@
     bool ClassFactory<T>::create(const std::string& name)
     {
-        COUT(4) << "*** Create entry for " << name << " in Factory." << std::endl;
-        ClassIdentifier<T>::getIdentifier()->addFactory(new ClassFactory<T>);
-        Factory::add(name, ClassIdentifier<T>::getIdentifier());
+        COUT(4) << "*** ClassFactory: Create entry for " << name << " in Factory." << std::endl;
+        ClassManager<T>::getIdentifier()->addFactory(new ClassFactory<T>);
+        Factory::add(name, ClassManager<T>::getIdentifier());
 
         return true;
Index: /code/trunk/src/orxonox/core/ClassManager.h
===================================================================
--- /code/trunk/src/orxonox/core/ClassManager.h	(revision 871)
+++ /code/trunk/src/orxonox/core/ClassManager.h	(revision 871)
@@ -0,0 +1,155 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file ClassManager.h
+    @brief Definition and Implementation of the ClassManager template.
+
+    The ClassManager is a helper-class for ClassIdentifier. Because ClassIdentifiers must
+    be unique, they are created through the IdentifierDistributor-class to assure the
+    uniqueness of the ClassIdentifier. But accessing Identifiers through IdentifierDistributor
+    is slow, because it uses strings and a map. Thats why we use the ClassManager-template: It's
+    a singleton like ClassIdentifier, but it doesn't hurt if there are multiple instances in
+    different libraries, because they all store the same pointer to the unique ClassIdentifier
+    which they've retrieved through IdentifierDistributor.
+*/
+
+#ifndef _ClassManager_H__
+#define _ClassManager_H__
+
+#include <string>
+
+#include "Identifier.h"
+#include "IdentifierDistributor.h"
+
+#include "CorePrereqs.h"
+
+namespace orxonox
+{
+    //! ClassManager is a helper class to allow faster access on the ClassIdentifiers.
+    /**
+        Because accessing the IdentifierDistributor is slow, the ClassManager accesses it once
+        and stores the result in a member-variable. IdentifierDistributor assures the uniqueness
+        of the ClassIdentifier, even if there are multiple instances of the ClassManager-template
+        in different libraries.
+    */
+    template <class T>
+    class ClassManager
+    {
+        public:
+            static ClassManager<T>* getSingleton();
+            static ClassIdentifier<T>* getIdentifier();
+            static const std::string& getName();
+
+        private:
+            ClassManager();
+            ClassManager(const ClassIdentifier<T>& identifier) {}    // don't copy
+            ~ClassManager() {}                                       // don't delete
+
+            bool bInitialized_;                 //!< This is false until the ClassIdentifier gets assigned
+            ClassIdentifier<T>* identifier_;    //!< The unique ClassIdentifier for the class T
+    };
+
+    /**
+        @brief Constructor: Marks the ClassManager as uninitialized.
+    */
+    template <class T>
+    ClassManager<T>::ClassManager()
+    {
+        this->bInitialized_ = false;
+    }
+
+    /**
+        @brief Returns the one and only instance of this class for the template parameter T.
+        @return The instance
+    */
+    template <class T>
+    ClassManager<T>* ClassManager<T>::getSingleton()
+    {
+        static ClassManager<T> theOneAndOnlyInstance = ClassManager<T>();
+        return &theOneAndOnlyInstance;
+    }
+
+    /**
+        @brief Creates the only instance of this class for the template class T and retrieves a unique Identifier for the given name.
+        @return The unique Identifier
+    */
+    template <class T>
+    ClassIdentifier<T>* ClassManager<T>::getIdentifier()
+    {
+        // Check if the ClassManager is already initialized
+        if (!ClassManager<T>::getSingleton()->bInitialized_)
+        {
+            // Get the name of the class
+            std::string name = typeid(T).name();
+
+            // It's not -> retrieve the ClassIdentifier through IdentifierDistributor
+            COUT(4) << "*** ClassManager: Request Identifier Singleton for " << name << "." << std::endl;
+
+            // First create a ClassIdentifier in case there's no instance existing yet
+            ClassIdentifier<T>* temp = new ClassIdentifier<T>();
+
+            // Ask the IdentifierDistributor for the unique ClassIdentifier
+            ClassManager<T>::getSingleton()->identifier_ = (ClassIdentifier<T>*)IdentifierDistributor::getIdentifier(name, temp);
+
+            // If the retrieved Identifier differs from our proposal, we don't need the proposal any more
+            if (temp != ClassManager<T>::getSingleton()->identifier_)
+            {
+                COUT(4) << "*** ClassManager: Requested Identifier for " << name << " was already existing and got assigned." << std::endl;
+
+                // Delete the unnecessary proposal
+                delete temp;
+            }
+            else
+            {
+                COUT(4) << "*** ClassManager: Requested Identifier for " << name << " was not yet existing and got created." << std::endl;
+            }
+
+            ClassManager<T>::getSingleton()->bInitialized_ = true;
+        }
+
+        // Finally return the unique ClassIdentifier
+        return ClassManager<T>::getSingleton()->identifier_;
+    }
+
+    /**
+        @brief Returns the name of the class the ClassManager belongs to.
+        @return The name
+    */
+    template <class T>
+    const std::string& ClassManager<T>::getName()
+    {
+        static std::string unknownClassName = std::string("unknown");
+
+        if (ClassManager<T>::getSingleton()->bInitialized_)
+            return ClassManager<T>::getSingleton()->identifier_->getName();
+        else
+            return unknownClassName;
+    }
+}
+
+#endif /* _ClassManager_H__ */
